from tritetmesh.tetmesh import *
from numpy import *

refinement=0
# Peacewise Liner Complex,
plceditor = PLCEditor()
plceditor.clear()
# Add the coordinates for the vertices
chord = 0.1
span = 4.*chord
ds = 0.06 / (refinement + 1.0)*chord
R = 0.6*chord
scale_x = 5.08*chord
scale_y = span+5./3.*chord
scale_z = 3.81*chord

x1 = array([0., 1., 1., 0., 0., 1., 1., 0.],'d')*scale_x
y1 = array([0., 0., 1., 1., 0., 0., 1., 1.],'d')*scale_y
z1 = array([0., 0., 0., 0., 1., 1., 1., 1.],'d')*scale_z


circle_x_position = scale_x/2-chord/2
circle_z_position = scale_z/2


xx_ell = []
zz_ell = []
dtheta = ds/R/chord
theta_range = 2*pi/dtheta
new_dtheta = 2*pi/floor(theta_range)
theta = arange(0,2*pi,new_dtheta)
for a in theta:
	xx_ell.append((R*cos(a) )*1.5 + circle_x_position + chord/2)
	zz_ell.append((R*sin(a) ) + circle_z_position)

num_points = len(zz_ell)

x_ell = array(xx_ell*2,'d')
z_ell = array(zz_ell*2,'d')
y_ell = array([0.0]*num_points+ [span+chord/2]*num_points,'d')


#f=open('naca0012_order.txt','r')
f=open('naca0012_pan50.dat','r')
x0=[]
z0=[]
for line in f:
	line=line.split()
	x=line[0]
	z=line[1]
	x0.append(float(x)*chord+circle_x_position)
	z0.append(float(z)*chord+circle_z_position)
f.close()
num_circ_points = len(x0)


x_prof = array(x0*2,'d')
z_prof = array(z0*2,'d')
y_prof = array([0.0]*num_circ_points + [span]*num_circ_points,'d')


x = concatenate((x1, x_ell, x_prof))
y = concatenate((y1, y_ell, y_prof))
z = concatenate((z1, z_ell, z_prof))

plceditor.register_vertices(x,y,z)

# Add vertex markers
plceditor.add_vertex_marker(10,[0,1,2,3])
plceditor.add_vertex_marker(20,[4,5,6,7])
#plceditor.add_vertex_marker(30,range(8,8+num_circ_points*2))
#plceditor.add_vertex_marker(40,range(8+num_circ_points*2,8+\
#	num_circ_points*2+num_points*2))


# Facet with marker (sotto)
plceditor.add_facet([0,1,2,3],1,ds)
# Facet with marker (sopra)
plceditor.add_facet([4,5,6,7],2,ds)
# Facet with marker (sx)
plceditor.add_facet([0,1,5,4],3,ds)

plceditor.add_polygon_to_last_facet(range(8, 8+num_points))
plceditor.add_polygon_to_last_facet(range(8+num_points*2,8+num_points*2+num_circ_points))#, [scale_x/2,0.,scale_z/2])
plceditor.add_facet(range(8+num_points*2+num_circ_points,8+num_points*2+num_circ_points*2),7)
# Add collar facets
for facet in rectangle_collar(num_circ_points,8+num_points*2):
	plceditor.add_facet(facet,7)


plceditor.add_facet(range(8+num_points, 8+num_points*2))
for facet in rectangle_collar(num_points,8):
	plceditor.add_facet(facet)


# Add a hole and a region
plceditor.add_hole([scale_x/2,span/2,scale_z/2])
plceditor.add_region([circle_x_position-ds*10,span/2,scale_z/2],12, ds*chord*0.005)
plceditor.add_region([0.001,0.001,0.001], 11, ds*chord*0.6)


# Facet with marker(dietro)
plceditor.add_facet([1,2,6,5],4,ds)
# Facet with marker(davanti)
plceditor.add_facet([0,3,7,4],6,ds)
# Facet with marker(dx)
plceditor.add_facet([2,3,7,6],5,ds)



# Build the plc and close the editor
plceditor.save_plc('pippo')
plceditor.build('mymesh','True')
